package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    private T[] array;

    public ArrayUtility(T[] list) {
        this.array = list;
    }

    public  T[] removeValue(T valueToRemove){
        List<T> list = new ArrayList<T>(Arrays.asList(array));
        List<T> newList = new ArrayList<>();
        // this is lamda -----
//        Consumer<T> consumer = (n) -> {
//            if(n != valueToRemove) {
//                newList.add(n);
//            }
//        };
//        list.forEach(consumer);
        for(T element: list) {
            if(!element.equals(valueToRemove)) {
                newList.add(element);
            }
        }
        T[] objs = (T[])Array.newInstance(this.array.getClass().getComponentType(), newList.size());
        return (T[]) newList.toArray(objs);

    }



    public int countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
       ArrayUtility arrayUtility = new ArrayUtility(merge(arrayToMerge));
        return arrayUtility.getNumberOfOccurrences(valueToEvaluate);
    }

    public Object[] merge(T[] arr2){
        Object [] mergeArr = new Object[array.length + arr2.length];
        int counter = 0;
        for(T el : array) {
            mergeArr[counter] = el;
            counter++;
        }
        for(T el : arr2) {
            mergeArr[counter] = el;
            counter++;
        }
        return mergeArr;
    }

    public int getNumberOfOccurrences(T valueToEvaluate) {
        int count = 0;
        for(T el : array) {
            if(el.equals(valueToEvaluate)) {
                count++;
            }
        }
        return count;
    }



    public T getMostCommonFromMerge(T[] arrayToMerge){
        ArrayUtility arrayUtility = new ArrayUtility(merge(arrayToMerge));
        int tempCount = 0;
        T mostCommonEl = null;
        for(Object el : arrayUtility.array) {
            if(getNumberOfOccurrences((T)el) > tempCount) {
                tempCount = getNumberOfOccurrences((T)el);
                mostCommonEl = (T)el;
            }
        }
        return mostCommonEl;
    }



}
